# igraph Ű ġ

install.packages("igraph")

library(igraph)



#   

#edges <- c(1,2,2,3,3,1)

edges

g<-graph(edges, n=max(edges), directed=F)

g[]

g

plot(g, layout = layout.fruchterman.reingold, vertex.label=V(g)$number,edge.arrow.size=0.5)

plot(g, vertex.color ="green", vertex.size = 40, edge.color= 'red')



# Degree 

degree(g, mode='all')

degree(g, mode='in')

degree(g, mode='out')

diameter(g, directed=F, weights=NA)

edge_density(g,loops=F)

closeness(g, mode='all', weights=NA)

betweenness(g, directed=T, weights=NA)



# ѱ  Լ

Sys.setlocale("LC_CTYPE", "ko_KR.UTF-8")



#  ҷ

edges <- read.csv(file.choose(), header=T) #ѱ۸ 丮  

edges

nodes <- read.csv(file.choose(), header=T)

nodes



# edge Ͽ ù° ٰ ι° ٸ 

edgeslist <- data.frame(edges$Source, edges$Target)

edgeslist



#Ʈũ ۼ

net <-graph.data.frame(edgeslist, vertices=nodes,
                       
                       directed=F)

V(net) # vertex, node Ȯ

E(net) # edge, link Ȯ

#V(net)$label <- V(net)$Label # nodes ȭ Label  vertex  label  

#V(net)$label

V(net)$degree <- degree(net) # node degree Ͽ vertex  degree  

V(net)$degree

plot(net, vertex.label=V(net)$label)



#    ̻ 쿡 ׸׸

cut_dgree <- 3 # ذ 

r_net <- delete.vertices(net,V(net)[degree < cut_dgree]) #  ذ  node ϱ

V(r_net)

E(r_net)

V(r_net)$label

plot(r_net, vertex.label=V(r_net)$label)



# Network diagram ׸

plot(net, vertex.color = nodes$Cat, vertex.size = V(net)$degree*0.7, vertex.label=V(net)$label,
     
     vertex.label.cex=0.7, edge.color= 'red', layout=layout.fruchterman.reingold)

plot(r_net, vertex.color = nodes$Cat, vertex.size = V(r_net)$degree*0.7, vertex.label=V(r_net)$label,
     
     vertex.label.cex=0.7, edge.color= 'red', layout=layout.fruchterman.reingold) # ҵ Ʈũ



plot(net, vertex.color ="green", vertex.size = V(net)$degree*0.7, vertex.label=V(net)$label,
     
     vertex.label.cex=0.7, edge.color= 'red', layout=layout.graphopt)

plot(r_net, vertex.color ="green", vertex.size = V(r_net)$degree*0.7, vertex.label=V(r_net)$label,
     
     vertex.label.cex=0.7, edge.color= 'red', layout=layout.graphopt) # ҵ Ʈũ



plot(net, vertex.color ="green", vertex.size = V(net)$degree*0.7, vertex.label=V(net)$label,
     
     vertex.label.cex=0.7, edge.color= 'red', layout=layout.kamada.kawai)

plot(r_net, vertex.color ="green", vertex.size = V(r_net)$degree*0.7, vertex.label=V(r_net)$label,
     
     vertex.label.cex=0.7, edge.color= 'red', layout=layout.kamada.kawai) #ҵ Ʈũ 



# community  

cnet <- cluster_edge_betweenness(net)

plot(cnet, net, vertex.color ="green", vertex.size = V(net)$degree*0.7, vertex.label=V(net)$Label,
     
     vertex.label.cex=0.7, edge.color= 'red', layout=layout.kamada.kawai)



#tkplot(net)



# Two Mode Data νϱ

bipartite.mapping(net)

V(net)$type <- bipartite.mapping(net)$type #type 

V(net)$color <- ifelse(V(net)$type, "lightblue", "salmon") #type   ޸

V(net)$shape <- ifelse(V(net)$type, "circle", "square") #type   ޸

E(net)$color <- "lightgray"

plot(net,layout=layout.graphopt, vertex.size=7, vertex.label.cex=0.6)



# - Ǿִ Ʈũ - Ʈũ ٲ

bipartite_matrix <- as_incidence_matrix(net) #߻ ķ ȯ

bipartite_matrix

t(bipartite_matrix) #ġ 

Disease_matrix_prod <- t(bipartite_matrix) %*% bipartite_matrix #X'X 

diag(Disease_matrix_prod) <- 0 #밢Ҵ  0 ȯ

Disease_matrix_prod



# adjacency ķ Ʈũ 

Disease_mode <- graph_from_adjacency_matrix(Disease_matrix_prod, mode = "undirected", weighted = TRUE)

Disease_mode

E(Disease_mode)

V(Disease_mode)

E(Disease_mode)$weight

V(Disease_mode)$degree <- degree(Disease_mode)

V(Disease_mode)$degree

V(Disease_mode)[degree>10]

#V(Disease_mode)$label <- V(net)$Label

V(Disease_mode)$label

plot(Disease_mode)#, vertex.label=nodes$Label[!is.na(nodes$Cat)])

plot(Disease_mode, vertex.label=V(net)$Label)



#    ̻ 쿡 ׸׸

cut_dgree <- 3 # ذ 

r_Disease_mode <- delete.vertices(Disease_mode,V(Disease_mode)[degree < cut_dgree]) #  ذ  node ϱ

V(r_Disease_mode)

E(r_Disease_mode)

V(r_Disease_mode)$label

plot(r_Disease_mode) #, vertex.label=V(r_Disease_mode)$label)





r_Disease_mode <-delete.vertices(Disease_mode,V(Disease_mode)[degree<20])

V(r_Disease_mode)$label

plot(r_Disease_mode, vertex.color ="green", vertex.size = V(net)$degree*0.7, vertex.label=V(Disease_mode)$label,
     
     vertex.label.cex=0.7, edge.color= 'red', layout=layout.kamada.kawai)

plot(Disease_mode, vertex.color ="green", vertex.size = V(net)$degree*0.7,
     
     vertex.label.cex=0.7, edge.color= 'red', layout=layout.fruchterman.reingold)

#tkplot(Disease_mode)



R_net <-delete.vertices(net,V(net)[degree<5])

V(r_net)$label <- nodes$Label

